#ifndef HAVE_SKKFUNC_PRIVATE_H
#define HAVE_SKKFUNC_PRIVATE_H

#define DefaultItemSize (((sizeof (DefaultItem))/(sizeof (DefaultItem[0]))))

static SkkFuncItem DefaultItem[] =
{
	/* Backward Delete */
	{ (SKK_FUNC_JMODE | SKK_FUNC_ABBREV), QUERY_ALL , SKK_VK_BACK_SPACE, SKK_ALL_MASK, SKKFUNC_BACKWARD_DELETE, 0 , FALSE},
	{ (SKK_FUNC_JMODE | SKK_FUNC_ABBREV) , ~QUERY_NONE, SKK_VK_H, SKK_CONTROL_MASK, SKKFUNC_BACKWARD_DELETE, 0, FALSE},
	{ (SKK_FUNC_JMODE | SKK_FUNC_ABBREV), ~QUERY_NONE, SKK_VK_h, SKK_CONTROL_MASK, SKKFUNC_BACKWARD_DELETE, 0, FALSE},
	/* Completion */
	{ (SKK_FUNC_JMODE | SKK_FUNC_ABBREV), QUERY_NORMAL, SKK_VK_TAB, SKK_ALL_MASK , SKKFUNC_COMPLETE_BEGIN, 0, FALSE},
	{ (SKK_FUNC_JMODE | SKK_FUNC_ABBREV) , QUERY_NORMAL, SKK_VK_PERIOD, SKK_ALL_MASK, SKKFUNC_COMPLETE_NEXT , 0, FALSE},
	{ (SKK_FUNC_JMODE | SKK_FUNC_ABBREV), QUERY_NORMAL, SKK_VK_COMMA, SKK_ALL_MASK, SKKFUNC_COMPLETE_PREV , 0, FALSE},
	/* Cancel */
	{ (SKK_FUNC_JMODE |  SKK_FUNC_ABBREV), QUERY_ALL, SKK_VK_g, SKK_CONTROL_MASK, SKKFUNC_CANCEL, 0, FALSE},
	{ (SKK_FUNC_JMODE |  SKK_FUNC_ABBREV), QUERY_ALL, SKK_VK_G, SKK_CONTROL_MASK, SKKFUNC_CANCEL, 0, FALSE},
	/* CodeTable */
	{ SKK_FUNC_JMODE, QUERY_ALL, SKK_VK_BACK_SLASH, SKK_ALL_MASK, SKKFUNC_CODETABLE, 0, FALSE},
	/* Kakutei */
	{ (SKK_FUNC_JMODE | SKK_FUNC_ABBREV), ~QUERY_NONE, SKK_VK_ENTER, SKK_ALL_MASK, SKKFUNC_KAKUTEI, SKK_VK_ENTER, FALSE},
	{ (SKK_FUNC_JMODE | SKK_FUNC_ABBREV), ~QUERY_NONE, SKK_VK_j, SKK_CONTROL_MASK, SKKFUNC_KAKUTEI, 0, FALSE},
	{ (SKK_FUNC_JMODE | SKK_FUNC_ABBREV), ~QUERY_NONE, SKK_VK_J, SKK_CONTROL_MASK, SKKFUNC_KAKUTEI, 0, FALSE},
	/* Kana */
	{ SKK_FUNC_JMODE, QUERY_NONE, SKK_VK_q, SKK_ALL_MASK, SKKFUNC_KANA_SWITCH, 0, FALSE },
	{ SKK_FUNC_JMODE, QUERY_ALL, SKK_VK_Q, SKK_ALL_MASK, SKKFUNC_KANA_SWITCH, 0, FALSE },
	/* Mode */
	{ (SKK_FUNC_JISX0208_LATIN | SKK_FUNC_LATIN), QUERY_ALL, SKK_VK_J, SKK_CONTROL_MASK, SKKFUNC_MODE_CHANGE, SKK_J_MODE, FALSE},
	{ (SKK_FUNC_JISX0208_LATIN | SKK_FUNC_LATIN), QUERY_ALL, SKK_VK_j, SKK_CONTROL_MASK, SKKFUNC_MODE_CHANGE, SKK_J_MODE, FALSE},
	{ SKK_FUNC_JMODE, QUERY_ALL, SKK_VK_l, SKK_ALL_MASK, SKKFUNC_MODE_CHANGE, SKK_LATIN_MODE, FALSE },
	{ SKK_FUNC_JMODE, QUERY_ALL, SKK_VK_L, SKK_ALL_MASK, SKKFUNC_MODE_CHANGE, SKK_JISX0208_LATIN_MODE , FALSE },
	{ SKK_FUNC_JMODE, QUERY_ALL, SKK_VK_SLASH, SKK_ALL_MASK, SKKFUNC_MODE_CHANGE, SKK_ABBREV_MODE, FALSE},
	/* Postfix & Prefix */
	{ (SKK_FUNC_JMODE | SKK_FUNC_ABBREV), QUERY_ALL, SKK_VK_GREATER, SKK_ALL_MASK, SKKFUNC_POSTFIX, SKK_VK_GREATER, FALSE},
	{ (SKK_FUNC_JMODE | SKK_FUNC_ABBREV), QUERY_NORMAL, SKK_VK_LESS, SKK_ALL_MASK, SKKFUNC_PREFIX, SKK_VK_LESS, FALSE}, 
	/* Today */
	{ SKK_FUNC_JMODE, QUERY_ALL, SKK_VK_AT, SKK_ALL_MASK, SKKFUNC_TODAY, 0, FALSE},
	{ SKK_FUNC_JMODE, QUERY_NORMAL, SKK_VK_q, SKK_ALL_MASK, SKKFUNC_CATEGORY_CHANGE, 0, FALSE},
	/* Translate */
	{ (SKK_FUNC_JMODE | SKK_FUNC_ABBREV), ~QUERY_NONE, SKK_VK_SPACE, SKK_ALL_MASK, SKKFUNC_TRANSLATE_BEGIN, 0, FALSE},
	/* Undo */
	{ SKK_FUNC_JMODE, QUERY_DONE, SKK_VK_x, SKK_NONE_MASK, SKKFUNC_UNDO, 0, FALSE},


};

#endif /* HAVE_SKKFUNC_PRIVATE_H */
