#include <time.h>
#include <errno.h>
#include <stdio.h>
#include "skkgadget.h"

gchar *
skk_gadget_get_jdate (void)
{
	time_t timeval;
	struct tm *ltime;
	gint n_year;
	gchar *s_year = NULL;
	gint i;
	gchar *day_tmp;
	gchar *ret = NULL;
	gchar *week_alist[] = {
		"","","","","","","",
	};
	SkkJDateNode jnode[] = {
		{ 1867, "" },
		{ 1911, "" },
		{ 1925, "" },
		{ 1988, "" },
		{    0, "ʿ" },
	};

	if ((time (&timeval) == (time_t)-1)) {
		fprintf (stderr, "iiimf-skk: skk_gadget_get_jdate (%s)",
				g_strerror (errno));
		return NULL;
	}
	ltime = localtime (&timeval);
	n_year = ltime->tm_year + 1900;

	for (i = 0; jnode[i].year != 0; i++) {
		if (n_year < jnode[i].year) {
			n_year -= (i > 0) ? jnode[i - 1].year : 0;
			s_year = jnode[i].y_name;
			break;
		}
	}
	if (!s_year) {
		s_year = jnode[i].y_name;
		n_year -= (i > 0) ? jnode[i - 1].year : 0;
	}
	day_tmp = g_strdup_printf ("%s%dǯ%d%d(%s)",
			s_year, n_year, ltime->tm_mon + 1, ltime->tm_mday, week_alist[ltime->tm_wday]);
#if 0
	ret = skkconv_get_jisx0208_latin_from_str (day_tmp, TRUE);
	g_free (day_tmp);
#else
	ret = day_tmp;
#endif
	return ret;
}

#ifdef SKKGADGET_DEBUG
int
main (void)
{
	g_message ("%s",skk_gadget_get_jdate ());
	return 0;
}
#endif
